diff --git a/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberUnsubscribe.uml b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberUnsubscribe.uml
new file mode 100644
index 0000000..a7d0d8b
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/hrtsubscriber/urtHrtSubscriberUnsubscribe.uml
@@ -0,0 +1,100 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtHrtSubscriberUnsubscribe()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_hrtsubscriber_t* --
+  The HRT subscriber to be unsubscribed.
+  Must not be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on sucess.
+  Returns ""URT_STATUS_UNSUBSCRIBE_NOTOPIC"" if the subscriber is not associated to a topic.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  fork
+    :unregister event;
+    note
+      Must be within lock because of HRT counter.
+    endnote
+  fork again
+    :decrement topic's HRT counter;
+  fork again
+    #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\ndecrement counter of subscribers (@topic);
+  fork again
+    partition "//URT_CFG_PUBSUB_QOS_RATECHECKS == true//" #EEEEEE {
+      #EEEEEE:remove self from topic's list of HRT subscribers;
+      if (Was the most critical subscriber?) then (yes)
+        #EEEEEE:update QoS rate timer (@topic) wrt. most critical HRT subscriber;
+      else (no)
+      endif
+    }
+  fork again
+    partition "fetch pending messages" {
+      :access last read message;
+      while (Timestamp of next message is younger?) is (yes)
+        :proceed to next message;
+        fork
+          :decrement message's HRT counter;
+        fork again
+          #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\ndecremnt message's consumer counter;
+        endfork
+      endwhile (no)
+      if (The HRT counter of any message became 0?) then (yes)
+        :signal topic's condition variable;
+      else (no)
+      endif
+    }
+  endfork
+  :unlock topic;
+  :reset members;
+  note
+    -- urt_basesubscriber_t --
+    * **topic** ← ""NULL""
+    * **lastMessage** ← ""NULL""
+    * **lastMessageTime** ← 0
+  endnote
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_UNSUBSCRIBE_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberFetchLatestMessage.uml b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberFetchLatestMessage.uml
new file mode 100644
index 0000000..0f21f12
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberFetchLatestMessage.uml
@@ -0,0 +1,105 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtNrtSubscriberFetchLatestMessage()\n
+
+!include ../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_nrtsubscriber_t* --
+  The NRT subscriber that shall fetch the message.
+  Must not be ""NULL"".
+  -- **payload** : void* --
+  Pointer where to copy the payload to.
+  May be ""NULL"" for messages without payload.
+  -- **bytes** : size_t --
+  Payload size in bytes.
+  -- **latency** : urt_delay_t* --
+  The latency can be returned by reference.
+  May be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_FETCH_NOTOPIC"" if the subscriber is not associated to a topic.
+  Retruns ""URT_STATUS_FETCH_NOMESSAGE"" if there is no new message to fetch.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  $find_latest_message()
+  if (Timestamp equals local copy?) then (yes)
+    :unlock topic;
+    stop
+    note
+      Returns ""URT_STATUS_FETCH_NOMESSAGE"".
+    endnote
+  else (no)
+    fork
+      $fetch_message()
+    fork again
+      :calculate message latency;
+      note
+        Can be optimized in case all flags are disabled.
+      endnote
+      fork
+        #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+      fork again
+        partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+          if (Latency is lower than ""minLatency""?) then (yes)
+            #EEEEEE:update ""minLatency"" value;
+          elseif (Latency is greater than ""maxLatency""?) then (yes)
+            #EEEEEE:update ""maxLatency"" value;
+          else (no)
+          endif
+        }
+      fork again
+        if (Optional ""latency"" output argument given?) then (yes)
+          :set ""latency"" value;
+        else (no)
+        endif
+      fork again
+      endfork
+    endfork
+    :unlock topic;
+    stop
+    note
+      Returns ""URT_STATUS_OK"".
+    endnote
+  endif
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_FETCH_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberFetchNextMessage.uml b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberFetchNextMessage.uml
new file mode 100644
index 0000000..d5a01d1
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberFetchNextMessage.uml
@@ -0,0 +1,120 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtNrtSubscriberFetchNextMessage()\n
+
+!include ../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_nrtsubscriber_t* --
+  The NRT subscriber that shall fetch the message.
+  Must not be ""NULL"".
+  -- **payload** : void* --
+  Pointer where to copy the payload to.
+  May be ""NULL"" for messages without payload.
+  -- **bytes** : size_t --
+  Payload size in bytes.
+  -- **latency** : urt_delay_t* --
+  The latency can be returned by reference.
+  May be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_FETCH_NOTOPIC"" if the subscriber is not associated to a topic.
+  Retruns ""URT_STATUS_FETCH_NOMESSAGE"" if there is no new message to fetch.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  if (Timestamp of last read message equals local copy?) then (yes)
+    if (Next message is younger?) then (yes)
+      :proceed to next message;
+    else (no)
+      :unlock topic;
+      stop
+      note
+        Returns ""URT_STATUS_FETCH_NOMESSAGE"".
+      endnote
+    endif
+  else (no)
+    partition "find oldest message" {
+      repeat
+        :proceed to next message;
+      repeat while (Timestamp of next message is younger?) is (yes)
+    }
+  endif
+  fork
+    $fetch_message()
+  fork again
+    :calculate message latency;
+    note
+      Can be optimized in case all flags are disabled.
+    endnote
+    fork
+      #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+    fork again
+      partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+        if (Latency is lower than ""minLatency""?) then (yes)
+          #EEEEEE:update ""minLatency"" value;
+        elseif (Latency is greater than ""maxLatency""?) then (yes)
+          #EEEEEE:update ""maxLatency"" value;
+        else (no)
+        endif
+      }
+    fork again
+      if (Optional ""latency"" output argument given?) then (yes)
+        :set ""latency"" value;
+      else (no)
+      endif
+    endfork
+  fork again
+    partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+      fork
+        #EEEEEE:decrement counter of consumers left (@message);
+      fork again
+        #EEEEEE:increment counter of received messages;
+      endfork
+    }
+  endfork
+  :unlock topic;
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_FETCH_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberInit.uml b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberInit.uml
new file mode 100644
index 0000000..06ef255
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberInit.uml
@@ -0,0 +1,60 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtNrtSubscriberInit()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_nrtsubscriber_t* --
+  The NRT subscriber to initialize.
+  Must not be ""NULL"".
+  ====
+  -- **return** : void --
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+:initialize members;
+note
+  -- urt_basesubscriber_t --
+  * **topic** ← ""NULL""
+  * urtEventListenerInit(**evtListener**)
+  * **lastMessage** ← ""NULL""
+  * **lastMessageTime** ← 0
+  .. URT_CFG_PUBSUB_PROFILING == true ..
+  * **sumLatencies** ← 0
+  * **numMessagesReceived** ← 0
+  -- urt_nrtsubscriber_t --
+  .. URT_CFG_PUBSUB_PROFILING == true ..
+  * **minLatency** ← 0xF..F
+  * **maxLatency** ← 0
+endnote
+stop
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberSubscribe.uml b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberSubscribe.uml
new file mode 100644
index 0000000..6d55cf5
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberSubscribe.uml
@@ -0,0 +1,100 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtNrtSubscriberSubscribe()\n
+
+!include ../../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_nrtsubscriber_t* --
+  The NRT subscriber which shall subscribe to a topic.
+  Must not be ""NULL"".
+  -- **topic** : urt_topic_t* --
+  The topic to subscribe to.
+  Must not be ""NULL"".
+  -- **messages** : urt_message_t* --
+  ""NULL"" terminated list of messages to contribute to the topic.
+  Messages must not be associated to another topic.
+  Once a message has been contributed, it cannot be removed later.
+  May be ""NULL"" (no messages to contribute).
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_SUBSCRIBE_TOPICSET"" if the subscriber is already associated to a topic.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Is topic already set?) then (yes)
+  stop
+  note
+    Returns ""URT_STATUS_SUBSCRIBE_TOPICSET"".
+  endnote
+else (no)
+  fork
+    :set topic;
+  fork again
+    #EEEEEE:initialize members;
+    note #EEEEEE
+      -- urt_basesubscriber_t --
+      .. URT_CFG_PUBSUB_PROFILING == true ..
+      * **sumLatencies** ← 0
+      * **numMessagesReceived** ← 0
+      -- urt_nrtsubscriber_t --
+      .. URT_CFG_PUBSUB_PROFILING == true ..
+      * **minLatency** ← 0xF..F
+      * **maxLatency** ← 0
+    endnote
+  endfork
+  :lock topic;
+  fork
+    if (Messages to contribute?) then (yes)
+      $contribute_messages()
+    else (no)
+    endif
+  fork again
+    fork
+      :set message pointer to topic's latest message;
+    fork again
+      :copy timestamp from topic's latest message;
+    endfork
+  fork again
+    :register to topic's event source;
+  fork again
+    #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nincrement counter of subscribers (@topic);
+  endfork
+  :unlock topic;
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberUnsubscribe.uml b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberUnsubscribe.uml
new file mode 100644
index 0000000..87f0405
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/nrtsubscriber/urtNrtSubscriberUnsubscribe.uml
@@ -0,0 +1,71 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtNrtSubscriberUnsubscribe()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_nrtsubscriber_t* --
+  The NRT subscriber to be unsubscribed.
+  Must not be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on sucess.
+  Returns ""URT_STATUS_UNSUBSCRIBE_NOTOPIC"" if the subscriber is not associated to a topic.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nlock topic;
+  fork
+    :unregister event;
+  fork again
+    #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\ndecrement counter of subscribers (@topic);
+  endfork
+  #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\nunlock topic;
+  :reset members;
+  note
+    -- urt_basesubscriber_t --
+    * **topic** ← ""NULL""
+    * **lastMessage** ← ""NULL""
+    * **lastMessageTime** ← 0
+  endnote
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_UNSUBSCRIBE_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberCalculateUsefulness.uml b/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberCalculateUsefulness.uml
new file mode 100644
index 0000000..55a3dba
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberCalculateUsefulness.uml
@@ -0,0 +1,55 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtSrtSubscriberCalculateUsefulness()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_srtsubscriber_t* --
+  The SRT subscriber to calculate a usefulness for.
+  Must not be ""NULL"".
+  -- **latency** : urt_delay_t --
+  Latency (of a message) as argument to calculate usefulness.
+  ====
+  -- **return** : float --
+  Returns the usefulness as a value within [0,1].
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+:execute the subscriber's ""usefulnesscb"" function;
+note
+  The callback function must never return a negative value or a value greater than 1.
+endnote
+stop
+note
+  Returns callback result value.
+endnote
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberFetchLatestMessage.uml b/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberFetchLatestMessage.uml
new file mode 100644
index 0000000..5cae8d1
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberFetchLatestMessage.uml
@@ -0,0 +1,105 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtSrtSubscriberFetchLatestMessage()\n
+
+!include ../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_srtsubscriber_t* --
+  The SRT subscriber that shall fetch the message.
+  Must not be ""NULL"".
+  -- **payload** : void* --
+  Pointer where to copy the payload to.
+  May be ""NULL"" for messages without payload.
+  -- **bytes** : size_t --
+  Payload size in bytes.
+  -- **latency** : urt_delay_t* --
+  The latency can be returned by reference.
+  May be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_FETCH_NOTOPIC"" if the subscriber is not associated to a topic.
+  Retruns ""URT_STATUS_FETCH_NOMESSAGE"" if there is no new message to fetch.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  $find_latest_message()
+  if (Timestamp equals local copy?) then (yes)
+    :unlock topic;
+    stop
+    note
+      Returns ""URT_STATUS_FETCH_NOMESSAGE"".
+    endnote
+  else (no)
+    fork
+      $fetch_message()
+    fork again
+      :calculate message latency;
+      note
+        Can be optimized in case all flags are disabled.
+      endnote
+      fork
+        #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+      fork again
+        partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+          if (Latency is lower than ""minLatency""?) then (yes)
+            #EEEEEE:update ""minLatency"" value;
+          elseif (Latency is greater than ""maxLatency""?) then (yes)
+            #EEEEEE:update ""maxLatency"" value;
+          else (no)
+          endif
+        }
+      fork again
+        if (Optional ""latency"" output argument given?) then (yes)
+          :set ""latency"" value;
+        else (no)
+        endif
+      fork again
+      endfork
+    endfork
+    :unlock topic;
+    stop
+    note
+      Returns ""URT_STATUS_OK"".
+    endnote
+  endif
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_FETCH_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberFetchNextMessage.uml b/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberFetchNextMessage.uml
new file mode 100644
index 0000000..32ccde0
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberFetchNextMessage.uml
@@ -0,0 +1,120 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtSrtSubscriberFetchNextMessage()\n
+
+!include ../functions.iuml
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_srtsubscriber_t* --
+  The SRT subscriber that shall fetch the message.
+  Must not be ""NULL"".
+  -- **payload** : void* --
+  Pointer where to copy the payload to.
+  May be ""NULL"" for messages without payload.
+  -- **bytes** : size_t --
+  Payload size in bytes.
+  -- **latency** : urt_delay_t* --
+  The latency can be returned by reference.
+  May be ""NULL"".
+  ====
+  -- **return** : urt_status_t --
+  Returns ""URT_STATUS_OK"" on success.
+  Returns ""URT_STATUS_FETCH_NOTOPIC"" if the subscriber is not associated to a topic.
+  Retruns ""URT_STATUS_FETCH_NOMESSAGE"" if there is no new message to fetch.
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+if (Associated to a topic?) then (yes)
+  :lock topic;
+  if (Timestamp of last read message equals local copy?) then (yes)
+    if (Next message is younger?) then (yes)
+      :proceed to next message;
+    else (no)
+      :unlock topic;
+      stop
+      note
+        Returns ""URT_STATUS_FETCH_NOMESSAGE"".
+      endnote
+    endif
+  else (no)
+    partition "find oldest message" {
+      repeat
+        :proceed to next message;
+      repeat while (Timestamp of next message is younger?) is (yes)
+    }
+  endif
+  fork
+    $fetch_message()
+  fork again
+    :calculate message latency;
+    note
+      Can be optimized in case all flags are disabled.
+    endnote
+    fork
+      #EEEEEE:..//URT_CFG_PUBSUB_PROFILING == true//..\naccumulate ""sumLatencies"" value;
+    fork again
+      partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+        if (Latency is lower than ""minLatency""?) then (yes)
+          #EEEEEE:update ""minLatency"" value;
+        elseif (Latency is greater than ""maxLatency""?) then (yes)
+          #EEEEEE:update ""maxLatency"" value;
+        else (no)
+        endif
+      }
+    fork again
+      if (Optional ""latency"" output argument given?) then (yes)
+        :set ""latency"" value;
+      else (no)
+      endif
+    endfork
+  fork again
+    partition "//URT_CFG_PUBSUB_PROFILING == true//" #EEEEEE {
+      fork
+        #EEEEEE:decrement counter of consumers left (@message);
+      fork again
+        #EEEEEE:increment counter of received messages;
+      endfork
+    }
+  endfork
+  :unlock topic;
+  stop
+  note
+    Returns ""URT_STATUS_OK"".
+  endnote
+else (no)
+  stop
+  note
+    Returns ""URT_STATUS_FETCH_NOTOPIC"".
+  endnote
+endif
+
+/'### OUTRO ##################################################################'/
+
+@enduml
diff --git a/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberInit.uml b/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberInit.uml
new file mode 100644
index 0000000..61e652e
--- /dev/null
+++ b/doc/activitydiagrams/subscriber/srtsubscriber/urtSrtSubscriberInit.uml
@@ -0,0 +1,62 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2020  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+/'### INTRO ##################################################################'/
+
+@startuml
+
+title **µRtWare**\nurtSrtSubscriberInit()\n
+
+/'### PARAMETERS & RETURN ####################################################'/
+
+note
+  -- **subscriber** : urt_srtsubscriber_t* --
+  The SRT subscriber to initialize.
+  Must not be ""NULL"".
+  ====
+  -- **return** : void --
+endnote
+
+/'### PROCEDURE ##############################################################'/
+
+start
+:initialize members;
+note
+  -- urt_basesubscriber_t --
+  * **topic** ← ""NULL""
+  * urtEventListenerInit(**evtListener**)
+  * **lastMessage** ← ""NULL""
+  * **lastMessageTime** ← 0
+  .. URT_CFG_PUBSUB_PROFILING == true ..
+  * **sumLatencies** ← 0
+  * **numMessagesReceived** ← 0
+  -- urt_srtsubscriber_t --
+  * **usefulnesscb** ← ""NULL""
+  * **cbparams** ← ""NULL""
+  .. URT_CFG_PUBSUB_PROFILING == true ..
+  * **minLatency** ← 0xF..F
+  * **maxLatency** ← 0
+endnote
+stop
+
+/'### OUTRO ##################################################################'/
+
+@enduml
